% Initliazation of the vocal folds model.
if ~exist('const','var'); const.model = 'ishi'; end
if ~isfield(const,'model'); const.model = 'ishi'; end

Qr = 0.2;
Qrc = 0.5;
Qam = 1; Qam2 = 1;%.25;
Qak = 1; Qak2 = 0.9;%0.9;%1/Qam2;

if strcmp(const.model,'ishi');  Qam2 = 0.2; Qak2 = 0.2; end

vfparam(1).Qr = Qr;
vfparam(1).Qrc = Qrc;
rho_folds = 1020;%1e-4*(1+Qam2)/(0.01*3e-3)/2.15/2;
hfolds = 1e-2*(0.065+0.05+0.115);%3e-3;
% hfolds = 3e-3;
%%%%%%%%%%%% Gender (M for male, F for female, Male for default)
if ~exist('Gend','var'); Gend = 'M'; end
%%%%%%%% Geometrical parameters
switch Gend    
    case 'M'
        lgi = 0.016 ; % glottis width (m)
        lvf = 0.003 ; % length of vocal folds (m)
%         lgi = 0.022 ; % glottis width (m)
%         lvf = 0.007 ; % length of vocal folds (m) 
        kspring = 10;
    case 'F'     
        lgi = 0.01;
        lvf = 0.003 ; % length of vocal folds (m)   
        kspring = 10;
        hfolds = hfolds*0.9;
end

% Mechanical parameters
m1ui = rho_folds*lgi*lvf*hfolds/(1+Qam2)/(strcmp(const.model,'ishi')+1)*2; % upper mass 1 (kg)
k1ui = kspring; % upper spring stiffness 1 (N/m)
r1ui = Qr*sqrt(k1ui*m1ui/2); % damping of the upper mass 1
m2ui = m1ui*Qam2; % upper mass 2 (kg)
k2ui = k1ui*Qak2; % upper spring stiffness 2 (N/m)
kcui = k1ui*Qrc; % upper coupling spring (N/m)
r2ui = Qr*sqrt(k2ui*m2ui/2); % damping of upper mass 2
m1di = m1ui*Qam ; % lower mass 1 (kg)
k1di = k1ui*Qak ; % lower spring stiffness 1 (N/m)
m2di = m2ui*Qam ; % lower mass 2 (kg)
r1di = Qr*sqrt(k1di*m1di/2); % damping of lower mass 1
k2di = k2ui*Qak; % lower spring stiffness 2 (N/m)
kcdi = kcui*Qak ; % lower coupling stiffness (N/m)
r2di = Qr*sqrt(k2di*m2di/2); % damping of lower mass 2

mvf = [ m1ui, m2ui; m1di, m2di ]; % mass matrix
kvf = [ k1ui, k2ui; k1di, k2di ]; % stiffness matrix
rvf = [ r1ui, r2ui; r1di, r2di ]; % damping matrix
kcvf = [ kcui; kcdi ]; % coupling stiffness
clear m1ui k1ui r1ui m2ui k2ui kcui r2ui m1di k1di m2di r1di k2di kcdi r2di

%%%%%%%% mass heights at rest
if ~exist('asg','var'); asg = 3.1314e-05; end % Default value for the subglottal area at the glottal connection
h0 = powtr( asg(end), 1.8, 1.2, 0 ); % 2*sqrt(asg(end)/pi) % height upstream the glottal constriction
h3 =  powtr( af(1).A(1,1), 1.8, 1.2, 0 ); % 2*sqrt(af(1).A(1,1)/pi);
y0 = 5e-5; % initial height of masses
y0 = 1e-11;
y0mat = y0*ones(2);
% %%%%%%%%% mass positions along x
x0 = 0; % 
if strcmp(const.model,'smooth')
    x0 = 0; %
    x1 = 2e-4;  % 1st mass
    x2 = x1 + lvf-2*x1;   % 2nd mass
    x3 = x2+x1;  % end of constriction
else    
    x1 = lvf/(1+Qam2);  % 1st mass
    x2 = lvf;   % 2nd mass
    x3 = x2+x1*1e-11;  % end of constriction
    vfparam(1).etha_k1 = 100; % Coefficient describing the  non linearity the springs
    vfparam(1).etha_k2 = 100;
    vfparam(1).etha_h1 = 500;
    vfparam(1).etha_h2 = 500;
end

xvec = [x0 x1 x2 x3 ];  % vector of positions
clear x0 x1 x2 x3

%%%%%%%%%%% Initialization of mass positions
yt = y0mat;%zeros(2); % positions at instant t
ytm1 = y0mat;%zeros(2); % positions at t-1
ytm2 = y0mat;%zeros(2); % positions at t-2
% Ugim1 = 0; % Initialization of the vocal flo
h1i = sum(y0mat(:,1));
h2i = sum(y0mat(:,2));
Hvec = [ h0, h1i, h2i, h3 ];
h_ab = 0.4e-4/0.016;
const.h_ab = h_ab; % Max abduction of vocal folds
vfparam(1).Ki = kvf; % = struct('Ki',kvf,'Mi',mvf,'Ri',rvf,'Kci',kcvf,'lgi',lgi,'lvf',lvf,'y0',y0mat,'xi',xvec,'Hi',Hvec);
vfparam(1).Mi = mvf;
vfparam(1).Ri = rvf;
vfparam(1).Kci = kcvf;
vfparam(1).lgi = lgi;
vfparam(1).lvf = lvf;
vfparam(1).y0 = y0mat;
vfparam(1).xi = xvec;
vfparam(1).Hi = Hvec;
% const.lgi = lgi;
